package CompilerProj.Parser;

import CompilerProj.Lexical.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents the syntactic unit:
  **
  ** class-dcl = class identifier [ extends identifier ] is body end             */

public class ClassDcl extends SyntacticUnit {
    
    
    public static final TokenSet STARTS = oneOf(CLASS);
    
    
    public ClassDcl ( TokenSet s ) {
        
        super(s);
        
    }; // constructor
    
    
    public void parse ( ) {
        
        Body         aBody;             // the class body
        
        expect(CLASS,"Class declaration expected",
                oneOf(stopSet,Body.STARTS,IDENTIFIER,EXTENDS,IS,END));
        expect(IDENTIFIER,"Class name expected",
                           oneOf(stopSet,Body.STARTS,EXTENDS,IS,END));
        check(oneOf(EXTENDS,IS),"Unexpected symbol",
                                      oneOf(stopSet,Body.STARTS,END));
        if ( tokenIs(EXTENDS) ) {
            accept();
            expect(IDENTIFIER,"Superclass name expected",
                                   oneOf(stopSet,Body.STARTS,IS,END));
        };
        expect(IS,"Unexpected symbol",oneOf(stopSet,Body.STARTS,END));
        aBody = new Body(oneOf(stopSet,END));
        aBody.parse();
        expect(END,"Unexpected symbol",stopSet);
        recognized("class-dcl");
        
    }; // parse
    
    
} // ClassDcl