package CompilerProj.Parser;

import CompilerProj.Lexical.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents the syntactic unit:
  **
  ** if-stmt = if expression then { statement } [ else { statement } ] end ;     */

public class IfStmt extends SyntacticUnit {
    
    
    public static final TokenSet STARTS = oneOf(IF);
    
    
    public IfStmt ( TokenSet s ) {
        
        super(s);
        
    }; // constructor
    
    
    public void parse ( ) {
        
        Expression anExpression;  // the condition
        Statement  aStmt;         // a statement
        
        expect(IF,"Unexpected symbol",
             oneOf(Expression.STARTS,Statement.STARTS,stopSet,THEN,ELSE,END,SEMI));
        anExpression = new Expression(
                              oneOf(Statement.STARTS,stopSet, THEN,ELSE,END,SEMI));
        anExpression.parse();
        expect(THEN,"Unexpected symbol",
               oneOf(Statement.STARTS,stopSet,ELSE,END,SEMI));
        while ( true ) {
            check(oneOf(Statement.STARTS,ELSE,END),"Statement expected",
                  oneOf(stopSet,SEMI));
            if ( tokenIn(oneOf(stopSet,ELSE,END,SEMI).except(Statement.STARTS)) )
                                                                             break;
            if ( tokenIn(Statement.STARTS) ) {
                aStmt = new Statement(
                                    oneOf(stopSet,Statement.STARTS,ELSE,END,SEMI));
                aStmt.parse();
            };
        };
        check(oneOf(ELSE,END),"Else expected",oneOf(stopSet,SEMI));
        if ( tokenIs(ELSE) ) {
            accept();
            while ( true ) {
                check(oneOf(Statement.STARTS,END),"Statement expected",
                      oneOf(stopSet,SEMI));
                if ( tokenIn(oneOf(stopSet,END,SEMI).except(Statement.STARTS)) )
                                                                             break;
                if ( tokenIn(Statement.STARTS) ) {
                    aStmt = new Statement(
                                         oneOf(stopSet,Statement.STARTS,END,SEMI));
                    aStmt.parse();
                };
            };
        };
        expect(END,"Unexpected symbol",oneOf(stopSet,SEMI));
        expect(SEMI,"Unexpected symbol",stopSet);
        recognized("if-stmt");
        
    }; // parse
    
    
} // IfStmt