package CompilerProj.Parser;

import CompilerProj.Lexical.*;

import static CompilerProj.Compiler.*;
import static CompilerProj.Lexical.TokenKind.*;
import static CompilerProj.Lexical.TokenSet.*;


/** This class represents the syntactic unit:
  **
  ** return-stmt = return expression ;                                           */

public class ReturnStmt extends SyntacticUnit {
    
    
    public static final TokenSet STARTS = oneOf(RETURN);
    
    
    public ReturnStmt ( TokenSet s ) {
        
        super(s);
        
    }; // constructor
    
    
    public void parse ( ) {
        
        Expression anExpression; // return value
        
        expect(RETURN,"Return statement expected",
               oneOf(stopSet,Expression.STARTS,SEMI));
        anExpression = new Expression(oneOf(stopSet,SEMI));
        anExpression.parse();
        expect(SEMI,"Unexpected symbol",stopSet);
        recognized("return-stmt");
        
    }; // parse
    
    
} // ReturnStmt